<script lang="ts">
import Vue from 'vue';
import ChevronLg from '../../static/nuxt-images/ico/chevron-lg.vue';
import SlpHorizontalRule from './horizontal-rule.vue';
import SlpColumn from './column.vue';

export default Vue.extend({
  name: 'CopyMedia',
  components: {
    SlpColumn,
    SlpHorizontalRule,
    ChevronLg,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
});
</script>

<template>
  <div>
    <div
      v-for="(block, index) in data.block"
      :key="index"
      class="container slp-mb-md-96 slp-mb-48"
      :data-aos="block.aos_animation"
      :data-aos-duration="block.aos_duration"
    >
      <span
        v-if="block.metadata"
        :id="block.metadata.id_tag || ''"
        class="slp-position-absolute"
        :data-slippers-scroll="block.metadata.id_tag || ''"
      ></span>
      <slp-column
        class="copy first-block"
        :class="{
          'first-block--inverted': block.inverted,
          'first-block--column': block.column,
          'first-block--inverted-column':
            block.inverted && block.column && block.column_size,
        }"
        :cols="block.column_size || 12"
        :data-aos="block.first_block_animation"
        :data-aos-duration="block.first_block_animation_duration"
      >
        <SlpTypography
          v-if="block.header"
          tag="h2"
          variant="heading3-bold"
          class="header slp-mb-16"
        >
          {{ block.header }}
        </SlpTypography>
        <SlpTypography v-if="block.subtitle" tag="h4" variant="heading4"
          >{{ block.subtitle }}
        </SlpTypography>
        <div class="copy__body">
          <div
            v-if="block.text"
            class="slp-mb-32"
            v-html="$md.render(block.text)"
          ></div>
          <slp-button
            v-if="block.link_href"
            class="slp-mr-8"
            :href="block.link_href"
            :data-ga-name="block.link_data_ga_name"
            :data-ga-location="block.link_data_ga_location"
          >
            {{ block.link_text }}
          </slp-button>
          <SlpButton
            v-if="block.secondary_link_href"
            variant="ghost"
            class="slp-color-primary-200"
            :href="block.secondary_link_href"
            :data-ga-name="block.secondary_link_data_ga_name"
            :data-ga-location="block.secondary_link_data_ga_location"
          >
            <SlpTypography tag="span" variant="body2-bold">
              {{ block.secondary_link_text }}
            </SlpTypography>
            <ChevronLg direction="right" />
          </SlpButton>
        </div>
      </slp-column>

      <slp-column
        class="media second-block"
        :class="{
          'second-block--inverted': block.inverted,
          'second-block--column': block.column,
          'second-block--media': block.image || block.video,
          'second-block--media-inverted-column':
            block.inverted && block.column && block.column_size,
          'media--no-max-height': block.no_max_height,
        }"
        :cols="block.column_size || 12"
        :data-aos="block.second_block_animation"
        :data-aos-duration="block.second_block_animation_duration"
      >
        <iframe
          v-if="block.video"
          :src="block.video.video_url"
          width="560"
          height="315"
          :title="block.header + ' YouTube Video'"
          allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
          allowfullscreen
        ></iframe>
        <div
          v-else-if="block.image"
          :class="{ centered: block.image.vertical_centered }"
        >
          <img
            class="media__img--desktop"
            :src="block.image.image_url"
            :alt="block.image.alt ? block.image.alt : ''"
            :style="{ filter: block.image.svg_filter_style }"
          />
          <img
            class="media__img--mobile"
            :src="
              block.image_mobile
                ? block.image_mobile.image_url
                : block.image.image_url
            "
            :alt="block.image_mobile ? block.image_mobile.alt : ''"
            :style="{ filter: block.image.svg_filter_style }"
          />
          <div
            v-if="block.image.caption"
            class="image-caption"
            v-html="$md.render(block.image.caption)"
          ></div>
        </div>
        <div
          v-else-if="block.miscellaneous"
          class="copy copy__body"
          v-html="$md.render(block.miscellaneous)"
        ></div>
        <slp-button
          v-if="block.media_link_href"
          :href="block.media_link_href"
          :data-ga-name="block.media_link_data_ga_name"
          :data-ga-location="block.media_link_data_ga_location"
        >
          {{ block.media_link_text }}
        </slp-button>
        <div class="copy__bottom_text">
          <SlpTypography v-if="block.bottom_text" tag="h2" variant="heading2"
            >{{ block.bottom_text }}
          </SlpTypography>
        </div>
      </slp-column>
      <SlpHorizontalRule v-if="!block.hide_horizontal_rule" />
    </div>
  </div>
</template>

<style lang="scss" scoped>
.container {
  display: grid;
  grid-template-columns: repeat(4, 1fr);
  padding: 0 15px;
  max-width: 100%;
  position: relative;

  @media (min-width: $breakpoint-lg) {
    grid-template-columns: repeat(12, 1fr);
    grid-auto-flow: column;
    grid-gap: $spacing-32;
  }

  hr {
    grid-column: 1 / span 12;
  }
}

.header-block {
  display: flex;
  align-items: center;
  padding-bottom: 20px;

  .header-text {
    color: $color-text-300;
    font-size: 32px;
    line-height: 36px;
    display: block;
    margin-bottom: 0;
  }

  img {
    &.header-icon {
      width: 48px !important;
      height: 48px;
    }
  }

  h3 {
    align-self: end;
  }
}

.copy {
  &::v-deep h3 {
    margin-bottom: $spacing-8;
  }

  &::v-deep h5 {
    font-size: 20px;
  }

  &::v-deep h4 {
    font-size: 24px;
  }

  &::v-deep h4,
  &::v-deep h5 {
    margin-top: $spacing-32;
    margin-bottom: $spacing-16;
  }

  &::v-deep img {
    width: 1.3rem;
    margin-right: 0.7rem;
    margin-bottom: -0.3rem;
  }

  &::v-deep blockquote {
    margin-left: 2rem;
  }

  h4 {
    color: $color-text-300;
    font-size: 19px;
    font-weight: 400;
    line-height: 24px;
    margin-bottom: 16px;

    @media (min-width: $breakpoint-lg) {
      font-size: 23px;
    }
  }

  &__body {
    grid-column: 1 / -1;
    color: $color-text-300;

    &::v-deep p {
      margin-bottom: 1em;
      font-size: 16px;
    }

    &::v-deep li {
      font-size: 16px;
    }

    & ::v-deep p a {
      color: $color-text-link-100;
    }
  }

  @media (max-width: $breakpoint-md) {
    a {
      width: 100%;
      margin: 0 0 $spacing-8 0;
    }
  }
}

.copy__bottom_text {
  grid-column: 1 / span 12;
  display: flex;
  justify-content: center;
  align-items: center;

  @media (min-width: $breakpoint-lg) {
    grid-row: 2/3;
  }
}

.media {
  &__img {
    &--mobile {
      display: block;

      @media (min-width: $breakpoint-sm) {
        display: none;
      }
    }

    &--desktop {
      display: none;

      @media (min-width: $breakpoint-sm) {
        display: block;
      }
    }
  }

  .image-caption {
    font-style: italic;
  }

  &--no-max-height {
    img {
      max-height: unset !important;
    }
  }

  img {
    width: 100%;
    object-fit: scale-down;
    max-height: 20rem;

    &[src*='\.svg'] {
      object-fit: fill;
    }
  }

  iframe {
    display: block;
    margin: 0 auto;
    max-width: 100%;
    border: 1px solid #f2f2f2;
  }
}

.first-block {
  grid-column: 1 / 12;
  margin-bottom: $spacing-24;

  @media (min-width: $breakpoint-md) {
    margin-bottom: 0;
  }

  &.slp-col-md-8.first-block--column {
    margin: 0 auto; // centers Topics content with embedded video
  }

  &--column {
    grid-column: 1 / 12;

    &.first-block--inverted {
      grid-row: 2;
    }
  }

  @media (min-width: $breakpoint-lg) {
    grid-column: 1 / span 6;
    padding-right: $spacing-16;
    padding-left: 0;

    &--inverted {
      grid-column: 7 / span 6;
      padding-right: 0;
      padding-left: $spacing-16;

      &-column {
        margin: 0 auto;
      }
    }

    &--column {
      grid-column: 1 / span 12;
    }
  }
}

.second-block {
  grid-column: 1 / 12;

  &.slp-col-md-8.second-block--column {
    margin: 0 auto $spacing-64 auto; // centers Topics content with embedded video
  }

  &--media {
    min-height: 200px;

    &-inverted-column {
      margin: 0 auto;
    }
  }

  &--column {
    grid-column: 1 / 12;

    &.second-block--inverted {
      grid-row: 1;
    }
  }

  @media (min-width: $breakpoint-lg) {
    grid-column: 7 / span 6;
    padding: 0;

    &--inverted {
      grid-column: 1 / span 6;
      padding: 0;
    }

    &--column {
      grid-column: 1 / span 12;
    }

    &--column + &--inverted {
      grid-row: 1;
    }

    &--centered {
      align-self: center;
    }
  }

  & > div {
    width: 100%;

    &.centered {
      align-self: center;
    }
  }
}
</style>
